diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/model/lr-wpan-mac.h ns-3.38/src/lr-wpan/model/lr-wpan-mac.h
--- ns-3.37/src/lr-wpan/model/lr-wpan-mac.h	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/model/lr-wpan-mac.h	2023-03-16 20:54:23.632868500 -0700
@@ -56,20 +56,20 @@
  *
  * Tx options
  */
-typedef enum
+enum LrWpanTxOption
 {
     TX_OPTION_NONE = 0,    //!< TX_OPTION_NONE
     TX_OPTION_ACK = 1,     //!< TX_OPTION_ACK
     TX_OPTION_GTS = 2,     //!< TX_OPTION_GTS
     TX_OPTION_INDIRECT = 4 //!< TX_OPTION_INDIRECT
-} LrWpanTxOption;
+};
 
 /**
  * \ingroup lr-wpan
  *
  * MAC states
  */
-typedef enum
+enum LrWpanMacState
 {
     MAC_IDLE,               //!< MAC_IDLE
     MAC_CSMA,               //!< MAC_CSMA
@@ -81,45 +81,45 @@
     MAC_GTS,                //!< MAC_GTS
     MAC_INACTIVE,           //!< MAC_INACTIVE
     MAC_CSMA_DEFERRED       //!< MAC_CSMA_DEFERRED
-} LrWpanMacState;
+};
 
 /**
  * \ingroup lr-wpan
  *
  * Superframe status
  */
-typedef enum
+enum SuperframeStatus
 {
     BEACON,  //!< The Beacon transmission or reception Period
     CAP,     //!< Contention Access Period
     CFP,     //!< Contention Free Period
     INACTIVE //!< Inactive Period or unslotted CSMA-CA
-} SuperframeStatus;
+};
 
 /**
  * \ingroup lr-wpan
  *
  * Superframe type
  */
-typedef enum
+enum SuperframeType
 {
     OUTGOING = 0, //!< Outgoing Superframe
     INCOMING = 1  //!< Incoming Superframe
-} SuperframeType;
+};
 
 /**
  * \ingroup lr-wpan
  *
  * Indicates a pending MAC primitive
  */
-typedef enum
+enum PendingPrimitiveStatus
 {
     MLME_NONE = 0,      //!< No pending primitive
     MLME_START_REQ = 1, //!< Pending MLME-START.request primitive
     MLME_SCAN_REQ = 2,  //!< Pending MLME-SCAN.request primitive
     MLME_ASSOC_REQ = 3, //!< Pending MLME-ASSOCIATION.request primitive
     MLME_SYNC_REQ = 4   //!< Pending MLME-SYNC.request primitive
-} PendingPrimitiveStatus;
+};
 
 namespace TracedValueCallback
 {
@@ -149,47 +149,47 @@
  *
  * table 80 of 802.15.4
  */
-typedef enum
+enum LrWpanAddressMode
 {
     NO_PANID_ADDR = 0,
     ADDR_MODE_RESERVED = 1,
     SHORT_ADDR = 2,
     EXT_ADDR = 3
-} LrWpanAddressMode;
+};
 
 /**
  * \ingroup lr-wpan
  *
  * table 83 of 802.15.4
  */
-typedef enum
+enum LrWpanAssociationStatus
 {
     ASSOCIATED = 0,
     PAN_AT_CAPACITY = 1,
     PAN_ACCESS_DENIED = 2,
     ASSOCIATED_WITHOUT_ADDRESS = 0xfe,
     DISASSOCIATED = 0xff
-} LrWpanAssociationStatus;
+};
 
 /**
  * \ingroup lr-wpan
  *
  * Table 30 of IEEE 802.15.4-2011
  */
-typedef enum
+enum LrWpanMlmeScanType
 {
     MLMESCAN_ED = 0x00,
     MLMESCAN_ACTIVE = 0x01,
     MLMESCAN_PASSIVE = 0x02,
     MLMESCAN_ORPHAN = 0x03
-} LrWpanMlmeScanType;
+};
 
 /**
  * \ingroup lr-wpan
  *
  * Table 42 of 802.15.4-2006
  */
-typedef enum
+enum LrWpanMcpsDataConfirmStatus
 {
     IEEE_802_15_4_SUCCESS = 0,
     IEEE_802_15_4_TRANSACTION_OVERFLOW = 1,
@@ -203,14 +203,14 @@
     IEEE_802_15_4_UNAVAILABLE_KEY = 9,
     IEEE_802_15_4_UNSUPPORTED_SECURITY = 10,
     IEEE_802_15_4_INVALID_PARAMETER = 11
-} LrWpanMcpsDataConfirmStatus;
+};
 
 /**
  * \ingroup lr-wpan
  *
  * Table 35 of IEEE 802.15.4-2011
  */
-typedef enum
+enum LrWpanMlmeStartConfirmStatus
 {
     MLMESTART_SUCCESS = 0,
     MLMESTART_NO_SHORT_ADDRESS = 1,
@@ -222,14 +222,14 @@
     MLMESTART_UNAVAILABLE_KEY = 7,
     MLMESTART_UNSUPPORTED_SECURITY = 8,
     MLMESTART_CHANNEL_ACCESS_FAILURE = 9
-} LrWpanMlmeStartConfirmStatus;
+};
 
 /**
  * \ingroup lr-wpan
  *
  * Table 31 of IEEE 802.15.4-2011
  */
-typedef enum
+enum LrWpanMlmeScanConfirmStatus
 {
     MLMESCAN_SUCCESS = 0,
     MLMESCAN_LIMIT_REACHED = 1,
@@ -240,14 +240,14 @@
     MLMESCAN_UNAVAILABLE_KEY = 6,
     MLMESCAN_UNSUPPORTED_SECURITY = 7,
     MLMESCAN_INVALID_PARAMETER = 8
-} LrWpanMlmeScanConfirmStatus;
+};
 
 /**
  * \ingroup lr-wpan
  *
  * Table 12 of IEEE 802.15.4-2011
  */
-typedef enum
+enum LrWpanMlmeAssociateConfirmStatus
 {
     MLMEASSOC_SUCCESS = 0,
     MLMEASSOC_FULL_CAPACITY = 1,
@@ -259,27 +259,27 @@
     MLMEASSOC_FRAME_TOO_LONG = 7,
     MLMEASSOC_UNSUPPORTED_LEGACY = 8,
     MLMEASSOC_INVALID_PARAMETER = 9
-} LrWpanMlmeAssociateConfirmStatus;
+};
 
 /**
  * \ingroup lr-wpan
  *
  * Table 37 of IEEE 802.15.4-2011
  */
-typedef enum
+enum LrWpanSyncLossReason
 {
     MLMESYNCLOSS_PAN_ID_CONFLICT = 0,
     MLMESYNCLOSS_REALIGMENT = 1,
     MLMESYNCLOSS_BEACON_LOST = 2,
     MLMESYNCLOSS_SUPERFRAME_OVERLAP = 3
-} LrWpanSyncLossReason;
+};
 
 /**
  * \ingroup lr-wpan
  *
  * Table 18 of IEEE 802.15.4-2011
  */
-typedef enum
+enum LrWpanMlmeCommStatus
 {
     MLMECOMMSTATUS_SUCCESS = 0,
     MLMECOMMSTATUS_TRANSACTION_OVERFLOW = 1,
@@ -289,14 +289,14 @@
     MLMECOMMSTATUS_COUNTER_ERROR = 5,
     MLMECOMMSTATUS_FRAME_TOO_LONG = 6,
     MLMECOMMSTATUS_INVALID_PARAMETER = 7
-} LrWpanMlmeCommStatus;
+};
 
 /**
  * \ingroup lr-wpan
  *
  * Table 39 of IEEE 802.15.4-2011
  */
-typedef enum
+enum LrWpanMlmePollConfirmStatus
 {
     MLMEPOLL_SUCCESS = 0,
     MLMEPOLL_CHANNEL_ACCESS_FAILURE = 2,
@@ -307,7 +307,46 @@
     MLMEPOLL_UNAVAILABLE_KEY = 7,
     MLMEPOLL_UNSUPPORTED_SECURITY = 8,
     MLMEPOLL_INVALID_PARAMETER = 9
-} LrWpanMlmePollConfirmStatus;
+};
+
+/**
+ * \ingroup lr-wpan
+ *
+ * Table 33 of IEEE 802.15.4-2011
+ */
+enum LrWpanMlmeSetConfirmStatus
+{
+    MLMESET_SUCCESS = 0,
+    MLMESET_READ_ONLY = 1,
+    MLMESET_UNSUPPORTED_ATTRIBUTE = 2,
+    MLMESET_INVALID_INDEX = 3,
+    MLMESET_INVALID_PARAMETER = 4
+};
+
+/**
+ * \ingroup lr-wpan
+ *
+ * IEEE802.15.4-2011 MAC PIB Attribute Identifiers Table 52 in section 6.4.2
+ *
+ */
+enum LrWpanMacPibAttributeIdentifier
+{
+    macBeaconPayload = 0,
+    macBeaconPayloadLength = 1
+    // TODO: complete other MAC pib attributes
+};
+
+/**
+ * \ingroup lr-wpan
+ *
+ * IEEE802.15.4-2011 PHY PIB Attributes Table 52 in section 6.4.2
+ */
+struct LrWpanMacPibAttributes : public SimpleRefCount<LrWpanMacPibAttributes>
+{
+    Ptr<Packet> macBeaconPayload;      //!< The contents of the beacon payload.
+    uint8_t macBeaconPayloadLength{0}; //!< The length in octets of the beacon payload.
+    // TODO: complete other MAC pib attributes
+};
 
 /**
  * \ingroup lr-wpan
@@ -318,8 +357,8 @@
 {
     LrWpanAddressMode m_coorAddrMode{SHORT_ADDR}; //!< The coordinator addressing mode corresponding
                                                   //!< to the received beacon frame.
-    uint16_t m_coorPanId{
-        0xffff}; //!< The PAN ID of the coordinator as specified in the received beacon frame.
+    uint16_t m_coorPanId{0xffff};                 //!< The PAN ID of the coordinator as specified in
+                                                  //!<  the received beacon frame.
     Mac16Address m_coorShortAddr; //!< The coordinator short address as specified in the coordinator
                                   //!< address mode.
     Mac64Address m_coorExtAddr;   //!< The coordinator extended address as specified in the
@@ -328,10 +367,10 @@
     uint8_t m_logChPage{0};       //!< The current channel page occupied by the network.
     SuperframeField m_superframeSpec; //!< The superframe specification as specified in the received
                                       //!< beacon frame.
-    bool m_gtsPermit{
-        false}; //!< TRUE if the beacon is from the PAN coordinator that is accepting GTS requests.
-    uint8_t m_linkQuality{
-        0}; //!< The LQI at which the network beacon was received. Lower values represent lower LQI.
+    bool m_gtsPermit{false};          //!< TRUE if the beacon is from the PAN coordinator
+                                      //!< that is accepting GTS requests.
+    uint8_t m_linkQuality{0};         //!< The LQI at which the network beacon was received.
+                                      //!< Lower values represent lower LQI.
     Time m_timeStamp; //!< Beacon frame reception time. Used as Time data type in ns-3 to avoid
                       //!< precision problems.
 };
@@ -603,6 +642,19 @@
 /**
  * \ingroup lr-wpan
  *
+ * MLME-SET.confirm params. See  802.15.4-2011   Section 6.2.11.2
+ */
+struct MlmeSetConfirmParams
+{
+    LrWpanMlmeSetConfirmStatus m_status{
+        MLMESET_UNSUPPORTED_ATTRIBUTE}; //!< The result of the request to write
+                                        //!< the PIB attribute.
+    LrWpanMacPibAttributeIdentifier id; //!< The id of the PIB attribute that was written.
+};
+
+/**
+ * \ingroup lr-wpan
+ *
  * This callback is called after a McpsDataRequest has been called from
  * the higher layer.  It returns a status of the outcome of the
  * transmission request
@@ -638,8 +690,7 @@
  *  \todo for now, we do not deliver all of the parameters in section
  *  802.15.4-2006 6.2.4.1 but just send up the packet.
  */
-typedef Callback<void, MlmeBeaconNotifyIndicationParams, Ptr<Packet>>
-    MlmeBeaconNotifyIndicationCallback;
+typedef Callback<void, MlmeBeaconNotifyIndicationParams> MlmeBeaconNotifyIndicationCallback;
 
 /**
  * \ingroup lr-wpan
@@ -703,6 +754,15 @@
 /**
  * \ingroup lr-wpan
  *
+ * This callback is called after a MlmeSetRequest has been called from
+ * the higher layer to set a PIB. It returns a status of the outcome of the
+ * write attempt.
+ */
+typedef Callback<void, MlmeSetConfirmParams> MlmeSetConfirmCallback;
+
+/**
+ * \ingroup lr-wpan
+ *
  * Class that implements the LR-WPAN MAC state machine
  */
 class LrWpanMac : public Object
@@ -714,48 +774,8 @@
      * \return the object TypeId
      */
     static TypeId GetTypeId();
-    // MAC sublayer constants
-    /**
-     * The minimum number of octets added by the MAC sublayer to the PSDU.
-     * See IEEE 802.15.4-2011, section 6.4.1, Table 51.
-     */
-    static constexpr uint32_t aMinMPDUOverhead = 9;
-
-    /**
-     * Length of a superframe slot in symbols. Defaults to 60 symbols in each
-     * superframe slot.
-     * See IEEE 802.15.4-2011, section 6.4.1, Table 51.
-     */
-    static constexpr uint32_t aBaseSlotDuration = 60;
-
-    /**
-     * Number of a superframe slots per superframe. Defaults to 16.
-     * See IEEE 802.15.4-2011, section 6.4.1, Table 51.
-     */
-    static constexpr uint32_t aNumSuperframeSlots = 16;
-
-    /**
-     * Length of a superframe in symbols. Defaults to
-     * aBaseSlotDuration * aNumSuperframeSlots in symbols.
-     * See IEEE 802.15.4-2011, section 6.4.1, Table 51.
-     */
-    static constexpr uint32_t aBaseSuperframeDuration = aBaseSlotDuration * aNumSuperframeSlots;
 
     /**
-     * The number of consecutive lost beacons that will
-     * cause the MAC sublayer of a receiving device to
-     * declare a loss of synchronization.
-     * See IEEE 802.15.4-2011, section 6.4.1, Table 51.
-     */
-    static constexpr uint32_t aMaxLostBeacons = 4;
-
-    /**
-     * The maximum size of an MPDU, in octets, that can be
-     * followed by a Short InterFrame Spacing (SIFS) period.
-     * See IEEE 802.15.4-2011, section 6.4.1, Table 51.
-     */
-    static constexpr uint32_t aMaxSIFSFrameSize = 18;
-    /**
      * Default constructor.
      */
     LrWpanMac();
@@ -766,7 +786,7 @@
      *
      * \return true, if the receiver is enabled during idle periods, false otherwise
      */
-    bool GetRxOnWhenIdle();
+    bool GetRxOnWhenIdle() const;
 
     /**
      * Set if the receiver should be enabled when the MAC is idle.
@@ -901,6 +921,16 @@
     void MlmePollRequest(MlmePollRequestParams params);
 
     /**
+     * IEEE 802.15.4-2011, section 6.2.11.1
+     * MLME-SET.request
+     * Attempts to write the given value to the indicated PIB attribute.
+     *
+     * \param id the attributed identifier
+     * \param attribute the attribute value
+     */
+    void MlmeSetRequest(LrWpanMacPibAttributeIdentifier id, Ptr<LrWpanMacPibAttributes> attribute);
+
+    /**
      * Set the CSMA/CA implementation to be used by the MAC.
      *
      * \param csmaCa the CSMA/CA implementation
@@ -1011,6 +1041,15 @@
      */
     void SetMlmePollConfirmCallback(MlmePollConfirmCallback c);
 
+    /**
+     * Set the callback for the confirmation of an attempt to write an attribute.
+     * The callback implements MLME-SET.confirm SAP of IEEE 802.15.4-2011,
+     * section 6.2.11.2
+     *
+     * \param c the callback
+     */
+    void SetMlmeSetConfirmCallback(MlmeSetConfirmCallback c);
+
     // interfaces between MAC and PHY
 
     /**
@@ -1078,7 +1117,7 @@
     /**
      * CSMA-CA algorithm calls back the MAC after executing channel assessment.
      *
-     * \param macState indicate BUSY oder IDLE channel condition
+     * \param macState indicate BUSY or IDLE channel condition
      */
     void SetLrWpanMacState(LrWpanMacState macState);
 
@@ -1255,6 +1294,19 @@
     SequenceNumber8 m_macBsn;
 
     /**
+     * The contents of the beacon payload.
+     * This value is set directly by the MLME-SET primitive.
+     * See IEEE 802.15.4-2011, section 6.4.2, Table 52.
+     */
+    Ptr<Packet> m_macBeaconPayload;
+
+    /**
+     * The length, in octets, of the beacon payload.
+     * See IEEE 802.15.4-2011, section 6.4.2, Table 52.
+     */
+    uint32_t m_macBeaconPayloadLength;
+
+    /**
      * The maximum number of retries allowed after a transmission failure.
      * See IEEE 802.15.4-2006, section 7.4.2, Table 86.
      */
@@ -1844,6 +1896,13 @@
     Ptr<LrWpanCsmaCa> m_csmaCa;
 
     /**
+     * This callback is used to report the result of an attribute writing request
+     * to the upper layers.
+     * See IEEE 802.15.4-2011, section 6.2.11.2.
+     */
+    MlmeSetConfirmCallback m_mlmeSetConfirmCallback;
+
+    /**
      * This callback is used to notify incoming beacon packets to the upper layers.
      * See IEEE 802.15.4-2011, section 6.2.4.1.
      */
@@ -1931,7 +1990,7 @@
     /**
      * The packet which is currently being sent by the MAC layer.
      */
-    Ptr<Packet> m_txPkt; // XXX need packet buffer instead of single packet
+    Ptr<Packet> m_txPkt;
 
     /**
      * The command request packet received. Briefly stored to proceed with operations
@@ -1940,15 +1999,14 @@
     Ptr<Packet> m_rxPkt;
 
     /**
-     * The short address used by this MAC. Currently we do not have complete
-     * extended address support in the MAC, nor do we have the association
-     * primitives, so this address has to be configured manually.
+     * The short address (16 bit address) used by this MAC. If supported,
+     * the short address must be assigned to the device by the coordinator
+     * during the association process.
      */
     Mac16Address m_shortAddress;
 
     /**
-     * The extended address used by this MAC. Extended addresses are currently not
-     * really supported.
+     * The extended 64 address (IEEE EUI-64) used by this MAC.
      */
     Mac64Address m_selfExt;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/model/lr-wpan-mac-header.cc ns-3.38/src/lr-wpan/model/lr-wpan-mac-header.cc
--- ns-3.37/src/lr-wpan/model/lr-wpan-mac-header.cc	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/model/lr-wpan-mac-header.cc	2023-03-16 20:54:23.632868500 -0700
@@ -40,7 +40,7 @@
     SetFrameVer(1); // Indicates an IEEE 802.15.4 frame
 }
 
-LrWpanMacHeader::LrWpanMacHeader(enum LrWpanMacType wpanMacType, uint8_t seqNum)
+LrWpanMacHeader::LrWpanMacHeader(LrWpanMacType wpanMacType, uint8_t seqNum)
 {
     SetType(wpanMacType);
     SetSeqNum(seqNum);
@@ -266,7 +266,7 @@
 }
 
 void
-LrWpanMacHeader::SetType(enum LrWpanMacType wpanMacType)
+LrWpanMacHeader::SetType(LrWpanMacType wpanMacType)
 {
     m_fctrlFrmType = wpanMacType;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/model/lr-wpan-mac-header.h ns-3.38/src/lr-wpan/model/lr-wpan-mac-header.h
--- ns-3.37/src/lr-wpan/model/lr-wpan-mac-header.h	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/model/lr-wpan-mac-header.h	2023-03-16 20:54:23.632868500 -0700
@@ -96,7 +96,7 @@
      * Data, ACK, Control MAC Header must have frame control and sequence number.
      * Beacon MAC Header must have frame control, sequence number, source PAN Id, source address.
      */
-    LrWpanMacHeader(enum LrWpanMacType wpanMacType, uint8_t seqNum);
+    LrWpanMacHeader(LrWpanMacType wpanMacType, uint8_t seqNum);
 
     ~LrWpanMacHeader() override;
 
@@ -104,7 +104,7 @@
      * Get the header type
      * \return the header type
      */
-    enum LrWpanMacType GetType() const;
+    LrWpanMacType GetType() const;
     /**
      * Get the Frame control field
      * \return the Frame control field
@@ -186,13 +186,13 @@
      */
     Mac64Address GetExtSrcAddr() const;
     /**
-     * Get the Auxiliary Security Header - Security Control Octect
-     * \return the Auxiliary Security Header - Security Control Octect
+     * Get the Auxiliary Security Header - Security Control Octet
+     * \return the Auxiliary Security Header - Security Control Octet
      */
     uint8_t GetSecControl() const;
     /**
-     * Get the Auxiliary Security Header - Frame Counter Octects
-     * \return the Auxiliary Security Header - Frame Counter Octects
+     * Get the Auxiliary Security Header - Frame Counter Octets
+     * \return the Auxiliary Security Header - Frame Counter Octets
      */
     uint32_t GetFrmCounter() const;
 
@@ -212,13 +212,13 @@
      */
     uint8_t GetSecCtrlReserved() const;
     /**
-     * Get the Auxiliary Security Header - Key Identifier - Key Source (2 Octects)
-     * \return the Auxiliary Security Header - Key Identifier - Key Source  (2 Octects)
+     * Get the Auxiliary Security Header - Key Identifier - Key Source (2 Octets)
+     * \return the Auxiliary Security Header - Key Identifier - Key Source  (2 Octets)
      */
     uint32_t GetKeyIdSrc32() const;
     /**
-     * Get the Auxiliary Security Header - Key Identifier - Key Source (4 Octects)
-     * \return the Auxiliary Security Header - Key Identifier - Key Source  (4 Octects)
+     * Get the Auxiliary Security Header - Key Identifier - Key Source (4 Octets)
+     * \return the Auxiliary Security Header - Key Identifier - Key Source  (4 Octets)
      */
     uint64_t GetKeyIdSrc64() const;
     /**
@@ -250,7 +250,7 @@
      * Set the Frame Control field "Frame Type" bits
      * \param wpanMacType the frame type
      */
-    void SetType(enum LrWpanMacType wpanMacType);
+    void SetType(LrWpanMacType wpanMacType);
     /**
      * Set the whole Frame Control field
      * \param frameControl the Frame Control field
@@ -342,12 +342,12 @@
     /* Auxiliary Security Header is only set if Sec Enable (SecU) field is set to 1 */
     /**
      * Set the auxiliary security header "Security Control" octet
-     * \param secLevel the "Security Control" octect
+     * \param secLevel the "Security Control" octet
      */
     void SetSecControl(uint8_t secLevel);
     /**
      * Set the auxiliary security header "Frame Counter" octet
-     * \param frmCntr the "Frame Counter" octect
+     * \param frmCntr the "Frame Counter" octet
      */
     void SetFrmCounter(uint32_t frmCntr);
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc ns-3.38/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc
--- ns-3.37/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc	2023-03-16 20:54:23.632868500 -0700
@@ -135,7 +135,7 @@
     SetCommandFrameType(CMD_RESERVED);
 }
 
-CommandPayloadHeader::CommandPayloadHeader(enum MacCommand macCmd)
+CommandPayloadHeader::CommandPayloadHeader(MacCommand macCmd)
 {
     SetCommandFrameType(macCmd);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/model/lr-wpan-mac-pl-headers.h ns-3.38/src/lr-wpan/model/lr-wpan-mac-pl-headers.h
--- ns-3.37/src/lr-wpan/model/lr-wpan-mac-pl-headers.h	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/model/lr-wpan-mac-pl-headers.h	2023-03-16 20:54:23.632868500 -0700
@@ -136,7 +136,7 @@
      * Constructor
      * \param macCmd the command type of this command header
      */
-    CommandPayloadHeader(enum MacCommand macCmd);
+    CommandPayloadHeader(MacCommand macCmd);
     /**
      * \brief Get the type ID.
      * \return the object TypeId
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/model/lr-wpan-mac-trailer.cc ns-3.38/src/lr-wpan/model/lr-wpan-mac-trailer.cc
--- ns-3.37/src/lr-wpan/model/lr-wpan-mac-trailer.cc	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/model/lr-wpan-mac-trailer.cc	2023-03-16 20:54:23.632868500 -0700
@@ -28,7 +28,8 @@
 
 NS_OBJECT_ENSURE_REGISTERED(LrWpanMacTrailer);
 
-const uint16_t LrWpanMacTrailer::LR_WPAN_MAC_FCS_LENGTH = 2;
+/// The length in octets of the IEEE 802.15.4 MAC FCS field
+constexpr uint16_t LR_WPAN_MAC_FCS_LENGTH = 2;
 
 LrWpanMacTrailer::LrWpanMacTrailer()
     : m_fcs(0),
@@ -135,7 +136,7 @@
 }
 
 bool
-LrWpanMacTrailer::IsFcsEnabled()
+LrWpanMacTrailer::IsFcsEnabled() const
 {
     return m_calcFcs;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/model/lr-wpan-mac-trailer.h ns-3.38/src/lr-wpan/model/lr-wpan-mac-trailer.h
--- ns-3.37/src/lr-wpan/model/lr-wpan-mac-trailer.h	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/model/lr-wpan-mac-trailer.h	2023-03-16 20:54:23.632868500 -0700
@@ -39,11 +39,6 @@
 {
   public:
     /**
-     * The length in octets of the IEEE 802.15.4 MAC FCS field
-     */
-    static const uint16_t LR_WPAN_MAC_FCS_LENGTH;
-
-    /**
      * Get the type ID.
      *
      * \return the object TypeId
@@ -99,7 +94,7 @@
      *
      * \return true, if FCS calculation is enabled, false otherwise.
      */
-    bool IsFcsEnabled();
+    bool IsFcsEnabled() const;
 
   private:
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/model/lr-wpan-net-device.cc ns-3.38/src/lr-wpan/model/lr-wpan-net-device.cc
--- ns-3.37/src/lr-wpan/model/lr-wpan-net-device.cc	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/model/lr-wpan-net-device.cc	2023-03-16 20:54:23.632868500 -0700
@@ -257,6 +257,10 @@
     {
         m_mac->SetShortAddress(Mac16Address::ConvertFrom(address));
     }
+    else if (Mac64Address::IsMatchingType(address))
+    {
+        m_mac->SetExtendedAddress(Mac64Address::ConvertFrom(address));
+    }
     else if (Mac48Address::IsMatchingType(address))
     {
         uint8_t buf[6];
@@ -292,6 +296,19 @@
     return pseudoAddress;
 }
 
+void
+LrWpanNetDevice::SetPanAssociation(uint16_t panId,
+                                   Mac64Address coordExtAddr,
+                                   Mac16Address coordShortAddr,
+                                   Mac16Address assignedShortAddr)
+{
+    NS_LOG_FUNCTION(this);
+    m_mac->SetPanId(panId);
+    m_mac->SetAssociatedCoor(coordExtAddr);
+    m_mac->SetAssociatedCoor(coordShortAddr);
+    m_mac->SetShortAddress(assignedShortAddr);
+}
+
 bool
 LrWpanNetDevice::SetMtu(const uint16_t mtu)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/model/lr-wpan-net-device.h ns-3.38/src/lr-wpan/model/lr-wpan-net-device.h
--- ns-3.37/src/lr-wpan/model/lr-wpan-net-device.h	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/model/lr-wpan-net-device.h	2023-03-16 20:54:23.632868500 -0700
@@ -135,6 +135,36 @@
      * \returns The short address.
      */
     Address GetAddress() const override;
+
+    /**
+     * This method is use to manually configure the coordinator through
+     * which the device or coordinator is associated. When assigning a short address
+     * the extended address must also be present.
+     *
+     * \param panId The id of the PAN used by the coordinator device.
+     *
+     * \param coordExtAddr The coordinator extended address (EUI-64) through which this
+     *                     device or coordinator is associated.
+     *
+     * \param coordShortAddr The coordinator assigned short address through which this
+     *                       device or coordinator is associated.
+     *                       [FF:FF] address indicates that the value is unknown.
+     *                       [FF:FE] indicates that the associated coordinator is using only
+     *                       its extended address.
+     *
+     *
+     * \param assignedShortAddr The assigned short address for this device.
+     *                          [FF:FF] address indicates that the device have no short address
+     *                                  and is not associated.
+     *                          [FF:FE] address indicates that the devices has associated but
+     *                          has not been allocated a short address.
+     *
+     */
+    void SetPanAssociation(uint16_t panId,
+                           Mac64Address coordExtAddr,
+                           Mac16Address coordShortAddr,
+                           Mac16Address assignedShortAddr);
+
     bool SetMtu(const uint16_t mtu) override;
     uint16_t GetMtu() const override;
     bool IsLinkUp() const override;
